searchData={"items":[{"type":"task","title":"mix threejs.configure","doc":"Configures Three.js imports in Phoenix app.js.\n\nAdds Three.js import and global window assignment to assets/js/app.js.","ref":"Mix.Tasks.Threejs.Configure.html"},{"type":"task","title":"Usage - mix threejs.configure","doc":"mix threejs.configure","ref":"Mix.Tasks.Threejs.Configure.html#module-usage"},{"type":"task","title":"Options - mix threejs.configure","doc":"--force    Overwrite existing imports","ref":"Mix.Tasks.Threejs.Configure.html#module-options"},{"type":"function","title":"Mix.Tasks.Threejs.Configure.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Threejs.Configure.html#run/1"},{"type":"task","title":"mix threejs.download","doc":"Downloads Three.js files from CDN.","ref":"Mix.Tasks.Threejs.Download.html"},{"type":"task","title":"Usage - mix threejs.download","doc":"mix threejs.download","ref":"Mix.Tasks.Threejs.Download.html#module-usage"},{"type":"task","title":"Options - mix threejs.download","doc":"--version VERSION    Specify Three.js version (default: 0.177.0)\n    --force             Overwrite existing files","ref":"Mix.Tasks.Threejs.Download.html#module-options"},{"type":"function","title":"Mix.Tasks.Threejs.Download.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Threejs.Download.html#run/1"},{"type":"task","title":"mix threejs.setup","doc":"Complete Three.js setup for Phoenix projects.\n\nDownloads Three.js files from CDN and configures app.js imports.","ref":"Mix.Tasks.Threejs.Setup.html"},{"type":"task","title":"Usage - mix threejs.setup","doc":"mix threejs.setup","ref":"Mix.Tasks.Threejs.Setup.html#module-usage"},{"type":"task","title":"Options - mix threejs.setup","doc":"--version VERSION    Specify Three.js version (default: 0.177.0)\n    --force             Overwrite existing files and imports","ref":"Mix.Tasks.Threejs.Setup.html#module-options"},{"type":"function","title":"Mix.Tasks.Threejs.Setup.run/1","doc":"Callback implementation for  Mix.Task.run/1 .","ref":"Mix.Tasks.Threejs.Setup.html#run/1"},{"type":"module","title":"PhoenixThree","doc":"Phoenix Three provides Mix tasks for managing Three.js dependencies in Phoenix projects.","ref":"PhoenixThree.html"},{"type":"module","title":"Installation - PhoenixThree","doc":"Add `phoenix_three` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:phoenix_three, \"~> 0.1.0\", only: :dev, runtime: false}\n  ]\nend\n```","ref":"PhoenixThree.html#module-installation"},{"type":"module","title":"Usage - PhoenixThree","doc":"Download Three.js files and set up imports:\n\n    mix threejs.setup","ref":"PhoenixThree.html#module-usage"},{"type":"module","title":"Available Tasks - PhoenixThree","doc":"- `mix threejs.setup` - Download Three.js files and configure app.js\n- `mix threejs.download` - Download Three.js files only\n- `mix threejs.configure` - Configure app.js imports only","ref":"PhoenixThree.html#module-available-tasks"},{"type":"function","title":"PhoenixThree.version/0","doc":"Returns the current version of the PhoenixThree package.","ref":"PhoenixThree.html#version/0"},{"type":"extras","title":"Phoenix Three","doc":"# Phoenix Three\n\nA Mix task package for easily integrating Three.js into Phoenix projects. Automatically downloads Three.js files from CDN and configures your app.js imports.","ref":"readme.html"},{"type":"extras","title":"Features - Phoenix Three","doc":"- **One-command setup** - Download and configure Three.js with a single command\n- **Version control** - Specify which Three.js version to download\n- **Smart imports** - Automatically adds imports to your app.js file\n- **Global access** - Makes THREE available globally for LiveView hooks\n- **Idempotent** - Safe to run multiple times, won't duplicate imports\n- **Phoenix optimized** - Follows Phoenix asset conventions","ref":"readme.html#features"},{"type":"extras","title":"Installation - Phoenix Three","doc":"Add `phoenix_three` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:phoenix_three, github: \"benjaminjacobberg/phoenix_three\", only: :dev, runtime: false}}\n  ]\nend\n```\n\nThen run:\n\n```bash\nmix deps.get\n```","ref":"readme.html#installation"},{"type":"extras","title":"Usage - Phoenix Three","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Quick Start - Phoenix Three","doc":"Set up Three.js in your Phoenix project with one command:\n\n```bash\nmix threejs.setup\n```\n\nThis will:\n1. Download Three.js files to `assets/vendor/three/`\n2. Add the import to your `assets/js/app.js`\n3. Make THREE available globally for hooks","ref":"readme.html#quick-start"},{"type":"extras","title":"Individual Commands - Phoenix Three","doc":"Download Three.js files only:\n```bash\nmix threejs.download\n```\n\nConfigure app.js imports only:\n```bash\nmix threejs.configure\n```","ref":"readme.html#individual-commands"},{"type":"extras","title":"Options - Phoenix Three","doc":"**Version Selection:**\n```bash\n# Download specific Three.js version\nmix threejs.setup --version 0.176.0\n```\n\n**Force Overwrite:**\n```bash\n# Overwrite existing files and imports\nmix threejs.setup --force\n```","ref":"readme.html#options"},{"type":"extras","title":"What Gets Added to Your Project - Phoenix Three","doc":"","ref":"readme.html#what-gets-added-to-your-project"},{"type":"extras","title":"Files Downloaded - Phoenix Three","doc":"- `assets/vendor/three/three.module.js` - Main ES6 module\n- `assets/vendor/three/three.core.js` - Core library\n- `assets/vendor/three/three.webgpu.js` - WebGPU renderer\n- `assets/vendor/three/three.webgpu.nodes.js` - WebGPU nodes\n- `assets/vendor/three/three.tsl.js` - Three Shading Language","ref":"readme.html#files-downloaded"},{"type":"extras","title":"App.js Modifications - Phoenix Three","doc":"The task adds this import to your `assets/js/app.js`:\n```javascript\nimport * as THREE from \"../vendor/three/three.module.js\";\n```\n\nAnd this global assignment after your `window.liveSocket = liveSocket` line:\n```javascript\n// Make THREE.js available globally for hooks\nwindow.THREE = THREE\n```","ref":"readme.html#app-js-modifications"},{"type":"extras","title":"Using Three.js in LiveView Hooks - Phoenix Three","doc":"After setup, you can use Three.js in your Phoenix LiveView hooks:\n\n```javascript\n// assets/js/app.js\nlet Hooks = {}\n\nHooks.ThreeScene = {\n  mounted() {\n    // THREE is available globally\n    const scene = new THREE.Scene()\n    const camera = new THREE.PerspectiveCamera(75, window.innerWidth / window.innerHeight, 0.1, 1000)\n    const renderer = new THREE.WebGLRenderer()\n\n    renderer.setSize(this.el.clientWidth, this.el.clientHeight)\n    this.el.appendChild(renderer.domElement)\n\n    // Your Three.js code here...\n  }\n}\n\nlet liveSocket = new LiveSocket(\"/live\", Socket, {hooks: Hooks, params: {_csrf_token: csrfToken}})\n```\n\nIn your LiveView template:\n```elixir\n  \n```","ref":"readme.html#using-three-js-in-liveview-hooks"},{"type":"extras","title":"Integration with Build Process - Phoenix Three","doc":"Add to your `mix.exs` aliases for automatic setup:\n\n```elixir\ndefp aliases do\n  [\n    setup: [\"deps.get\", \"threejs.setup\", \"assets.setup\", \"assets.build\"],\n    \"assets.deploy\": [\"threejs.setup\", \"assets.deploy\"]\n  ]\nend\n```","ref":"readme.html#integration-with-build-process"},{"type":"extras","title":"Available Three.js Versions - Phoenix Three","doc":"The package downloads from [CDNJS](https://cdnjs.com/libraries/three.js). You can use any version available there:\n\n- Latest: `mix threejs.setup` (currently 0.177.0)\n- Specific: `mix threejs.setup --version 0.176.0`\n- Legacy: `mix threejs.setup --version 0.150.0`","ref":"readme.html#available-three-js-versions"},{"type":"extras","title":"Troubleshooting - Phoenix Three","doc":"**\"assets/js/app.js not found\" error:**\n- Make sure you're running the command from your Phoenix project root\n- Ensure your Phoenix project has the standard asset structure\n\n**Import conflicts:**\n- Use `--force` flag to overwrite existing imports\n- Manually check your app.js if imports look incorrect\n\n**Version not found:**\n- Check available versions at [CDNJS Three.js](https://cdnjs.com/libraries/three.js)\n- Some very new versions might not be available on CDNJS yet","ref":"readme.html#troubleshooting"},{"type":"extras","title":"Contributing - Phoenix Three","doc":"Bug reports and pull requests are welcome on GitHub at https://github.com/benjaminjacobberg/phoenix_three.","ref":"readme.html#contributing"},{"type":"extras","title":"License - Phoenix Three","doc":"The package is available as open source under the terms of the [MIT License](https://opensource.org/licenses/MIT).","ref":"readme.html#license"},{"type":"extras","title":"Credits - Phoenix Three","doc":"- [Three.js](https://threejs.org) - The amazing 3D library\n- [CDNJS](https://cdnjs.com) - For hosting the Three.js files\n- [Phoenix Framework](https://phoenixframework.org) - The productive web framework","ref":"readme.html#credits"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.38.2"}}